#include "felulet.h"

using namespace std;

// zenetek olvassa
// Azt, hogy egy neknk cmzett zenet olvasott-e,
// az SUzenet struktra olvasott mezje jelz.
void UzenetOlvasasa(int dolgozo, int projektszama)
{
	bool voltuzenet = false;
	bool voltolvasattlan = false;
	for (auto &uzenet : g_uzenetek)
	{
		// Ha az zenet az aktulis projekthez tartozik,
		// s neknk vagy mindenkinek szl, s nem rtkels
		if (uzenet.projekt == projektszama
			&& (uzenet.cimzett == dolgozo || uzenet.cimzett == 0)
			&& !IsNumber(uzenet.tartalom))
		{
			// Ha neknk szl s olvasatlan,
			// akkor mostantl olvasott lesz.
			if (!uzenet.olvasott && uzenet.cimzett == dolgozo)
			{
				cout << "[OLVASATTLAN]" << endl;
				uzenet.olvasott = true;
				voltolvasattlan = true;
			}
			cout << "Felad: " << g_dolgozok[uzenet.felado].nev << endl;
			cout << "Dtum: " << uzenet.datum << endl;
			cout << "zenet: " << uzenet.tartalom << endl << endl;
			voltuzenet = true;
		}
	}
	if (!voltuzenet)
	{
		cout << "Nincsenek zenetek." << endl;
	}

	if (voltolvasattlan)
	{
		// Mentjk az zeneteket,
		// mert az olvasatlan zenetek olvasott vltak.
		MentesUzenetek();
	}
}

// zenet klds kivlasztott munkatrsnak
void UzenetKuldes(int dolgozo, int projektszama)
{
	cout << "Vlasszon munkatrsat: " << endl;

	// Munkatrsak kigyjtse s kirsa
	set<int> munkatarsak;
	for (auto &tagsag : g_tagsagok)
	{
		if (tagsag.munkatars != dolgozo && tagsag.projekt == projektszama)
		{
			munkatarsak.insert(tagsag.munkatars);
			cout << "\t" << tagsag.munkatars << ". " << g_dolgozok[tagsag.munkatars].nev << endl;
		}
	}

	cout << "Munkatrs szma: ";
	int cimzett;
	cin >> cimzett;
	cin.ignore(100, '\n');

	if (munkatarsak.find(cimzett) == munkatarsak.end())
	{
		cout << "Nincs ilyen munkatrs!" << endl;
		return;
	}

	cout << "zenet: ";
	SUzenet uzenet;
	uzenet.cimzett = cimzett;
	uzenet.felado = dolgozo;
	uzenet.datum = MaiDatum();
	uzenet.projekt = projektszama;
	uzenet.olvasott = false;
	getline(cin, uzenet.tartalom);

	// Ha szmot r be, kiegsztjk szkzkkel, hogy ne tekinthessk rtkelsnek
	if (IsNumber(uzenet.tartalom))
	{
		uzenet.tartalom += "  ";
	}

	g_uzenetek.push_back(uzenet);
	MentesUzenetek();
	cout << "zenet elkldve" << endl;
}

// Kzvetlen munkatrsaink listzsa
void KozvetlenMunkatarsak(int dolgozo, int projektszama, const set<int> &dolgozoprojektjei)
{
	// Megkeressk azokat a dolgozkat, akikkel van kzs projektnk
	cout << "Kzvetlen munkatrsak: " << endl;
	set<int> tarsak;
	for (auto &tagsag : g_tagsagok)
	{
		if (tagsag.munkatars != dolgozo
			&& dolgozoprojektjei.find(tagsag.projekt) != dolgozoprojektjei.end())
		{
			tarsak.insert(tagsag.munkatars);
		}
	}

	for (auto &dolgozo : tarsak)
	{
		cout << "\t" << dolgozo << ". " << g_dolgozok[dolgozo].nev << endl;
	}
}

// Az rtkelseink szmnak s tlagnak megtekintse
void Ertekelesek(int dolgozo, int projektszama)
{
	// rtkelsek megszmllsa
	int ertekelesek = 0, ertekelesatlag = 0;
	for (auto &uzenet : g_uzenetek)
	{
		if (dolgozo == uzenet.cimzett
			&& projektszama == uzenet.projekt
			&& IsNumber(uzenet.tartalom))
		{
			ertekelesek++;
			ertekelesatlag += stoi(uzenet.tartalom);
		}
	}

	if (ertekelesek)
	{
		ertekelesatlag /= ertekelesek;
		cout << "rtkelsek szma: " << ertekelesek << endl;
		cout << "rtkelsek tlaga: " << ertekelesatlag << endl;
	}
	else
	{
		cout << "Nincsenek rtkelsek" << endl;
	}
}

// zenet kldse mindenkinek a projekten bell
void UzenetKuldesMindenkinek(int dolgozo, int projektszama)
{
	cout << "zenet: ";
	SUzenet uzenet;
	uzenet.cimzett = 0;
	uzenet.felado = dolgozo;
	uzenet.datum = MaiDatum();
	uzenet.projekt = projektszama;
	uzenet.olvasott = false;
	getline(cin, uzenet.tartalom);

	// Ha szmot r be, kiegsztjk szkzkkel, hogy ne tekinthessk rtkelsnek
	if (IsNumber(uzenet.tartalom))
	{
		uzenet.tartalom += "  ";
	}

	g_uzenetek.push_back(uzenet);
	MentesUzenetek();
	cout << "zenet elkldve" << endl;
}

// rtkels kldse egy adott dolgoznak
void ErtekelesKuldes(int dolgozo, int projektszama)
{
	// Kigyjtjk a munkatrsainkat
	set<int> munkatarsak;
	for (auto &tagsag : g_tagsagok)
	{
		if (tagsag.munkatars != dolgozo && tagsag.projekt == projektszama)
		{
			munkatarsak.insert(tagsag.munkatars);
			cout << "\t" << tagsag.munkatars << ". " << g_dolgozok[tagsag.munkatars].nev << endl;
		}
	}

	if (munkatarsak.empty())
	{
		cout << "Nincsenek munkatrsak a projektben" << endl;
		return;
	}

	cout << "Vlasszon munkatrsat: " << endl;
	int cimzett = 0;
	cin >> cimzett; cin.ignore(100, '\n');

	if (munkatarsak.find(cimzett) == munkatarsak.end())
	{
		cout << "Nincs ilyen munkatrs!" << endl;
		return;
	}

	cout << "rtkels (0 - 100): ";
	SUzenet uzenet;
	uzenet.cimzett = cimzett;
	uzenet.felado = dolgozo;
	uzenet.datum = MaiDatum();
	uzenet.projekt = projektszama;
	uzenet.olvasott = false;
	getline(cin, uzenet.tartalom);

	if (!IsNumber(uzenet.tartalom) || 0 > stoi(uzenet.tartalom) || stoi(uzenet.tartalom) > 100)
	{
		cout << "Hibs rtkels" << endl;
	}
	else
	{
		g_uzenetek.push_back(uzenet);
		MentesUzenetek();
		cout << "rtkels elkldve" << endl;
	}
}

// Munkatsak rtkelseinek kirsa
void MunkatarsakErtekelesei(int dolgozo, int projektszama)
{
	for (auto &tagsag : g_tagsagok)
	{
		if (tagsag.munkatars != dolgozo && tagsag.projekt == projektszama)
		{
			// rtkelsek sszeszmolsa
			int ertekelesek = 0, osszeg = 0;
			for (auto &uzenet : g_uzenetek)
			{
				if (tagsag.munkatars == uzenet.cimzett
					&& uzenet.projekt == projektszama
					&& IsNumber(uzenet.tartalom))
				{
					ertekelesek++;
					osszeg += stoi(uzenet.tartalom);
				}
			}

			cout << g_dolgozok[tagsag.munkatars].nev << ":" << endl;
			if (ertekelesek)
			{
				cout << "\trtkelsek szma: " << ertekelesek << endl;
				cout << "\trtkelsek tlaga: " << osszeg / ertekelesek << endl;
			}
			else
			{
				cout << "\tNincsenek rtkelsek" << endl;
			}
		}
	}
}

void MunkatarsiFelulet(int dolgozo)
{
	CleanScreen();
	cout << "Vlassza ki a projekt szmt" << endl;

	// Kigyjtk, mely projekteken dolgozik a dolgoz
	set<int> dolgozoprojektjei;
	for (auto &tagsag : g_tagsagok)
	{
		if (dolgozo == tagsag.munkatars)
		{
			dolgozoprojektjei.insert(tagsag.projekt);
			cout << "\t" << tagsag.projekt << ". " << g_projektek[tagsag.projekt].nev << endl;
		}
	}
	if (dolgozoprojektjei.empty())
	{
		cout << "n nem dolgozik semmilyen projekten!" << endl;
		Pause();
		return;
	}
	else
	{
		cout << "Projekt szma: ";
		int projektszama;
		cin >> projektszama;
		cin.clear();
		cin.ignore(100, '\n');
		if (dolgozoprojektjei.find(projektszama) == dolgozoprojektjei.end())
		{
			cout << "n nem dolgozik ezen a projekten!" << endl;
			Pause();
			return;
		}

		// vezet-e az aktulis projekten
		bool vezeto = false;
		for (auto &tagsag : g_tagsagok)
		{
			if (tagsag.munkatars == dolgozo
				&& tagsag.projekt == projektszama
				&& tagsag.vezeto)
			{
				vezeto = true;
				break;
			}
		}

		while (true)
		{
			CleanScreen();

			// Menpontok
			int maxmenu = 4;
			cout << "Vlassza ki a menpont szmt:" << endl;
			cout << "\t1. zenetek olvassa" << endl;
			cout << "\t2. zenet kldse" << endl;
			cout << "\t3. Kzevetlen munkatrsak nvsora" << endl;
			cout << "\t4. rtkels megtekintse" << endl;
			if (vezeto)
			{
				cout << "\t5. Krzenet" << endl;
				cout << "\t6. rtkels kldse" << endl;
				cout << "\t7. A projekten dolgoz munkatrsak rtkelsei" << endl;
				maxmenu = 7;
			}
			cout << "\t0. Vissza" << endl;
			cout << "Menpont szma: ";

			// Vlasztott menpont szmnak bekrse
			int menu = -1;
			cin >> menu;
			cin.clear();
			cin.ignore(100, '\n');

			while (menu < 0 || menu > maxmenu)
			{
				cout << "Nincs ilyen menpont: " << menu << ", vlasszon msikat: " << endl;
				cin >> menu;
				cin.clear();
				cin.ignore(100, '\n');
			}

			CleanScreen();
			switch (menu)
			{
			case 0:
				return;
			case 1:
				UzenetOlvasasa(dolgozo, projektszama);
				break;
			case 2:
				UzenetKuldes(dolgozo, projektszama);
				break;
			case 3:
				KozvetlenMunkatarsak(dolgozo, projektszama, dolgozoprojektjei);
				break;
			case 4:
				Ertekelesek(dolgozo, projektszama);
				break;
			case 5:
				UzenetKuldesMindenkinek(dolgozo, projektszama);
				break;
			case 6:
				ErtekelesKuldes(dolgozo, projektszama);
				break;
			case 7:
				MunkatarsakErtekelesei(dolgozo, projektszama);
				break;
			}

			cout << endl;
			Pause();
		}
	}
}