#include <sstream>
#include "felulet.h"

using namespace std;

bool IsNumber(const string& str)
{
	for (char c : str)
	{
		if (!isdigit(c))
			return false;
	}
	return true;
}

// Vezet-e a dolgoz valamelyik projektben
bool Vezetoe(int dolgozo)
{
	for (auto &tagsag : g_tagsagok)
	{
		if (tagsag.munkatars == dolgozo && tagsag.vezeto)
		{
			return true;
		}
	}
	return false;
}

// Munkatrs adatainak megtekintse
void MunkatarsAdatok()
{
	CleanScreen();
	cout << "Egy munkatrs adatainak megtekintse" << endl
		 << "Munkatrsak: " << endl;

	for (auto &dolgozo : g_dolgozok)
	{
		cout << "\t" << dolgozo.first << ". " << dolgozo.second.nev << endl;
	}

	cout << endl << "A vlasztott munkatrs azonostja: ";
	int da = -1;
	cin >> da;
	cin.clear();
	cin.ignore(100, '\n');

	while (g_dolgozok.find(da) == g_dolgozok.end())
	{
		cout << "Nincs ilyen munkatrs!" << endl
			 << "Adjon meg msik azonostt: " << endl;

		cin >> da;
		cin.clear();
		cin.ignore(100, '\n');
	}
	cout << endl;

	int resztvesz = 0; // Hny projecktben vett rszt
	for (auto &tagsag : g_tagsagok)
	{
		if (tagsag.munkatars == da)
		{
			if (resztvesz == 0)
				cout << "A munkatrs az albbi projektben vesz/vett rszt: " << endl;

			cout << "\t" << tagsag.projekt << ". " << g_projektek[tagsag.projekt].nev << endl;
			resztvesz++;
		}
	}
	if (resztvesz == 0)
		cout << "A munkatrs egy projektben se vett rszt." << endl;
	cout << endl;

	bool vezeto = false;
	for (auto &tagsag : g_tagsagok)
	{
		if (tagsag.munkatars == da && tagsag.vezeto)
		{
			if (!vezeto)
			{
				cout << "A munkatrs az albbi projektben vezet: " << endl;
				vezeto = true;
			}
			cout << "\t" << tagsag.projekt << ". " << g_projektek[tagsag.projekt].nev << endl;
		}
	}
	if (!vezeto)
		cout << "A munkatrs egyik projektben se vezet." << endl;
	cout << endl;
	
	// tlag szmtsa rtkelsekbl
	vector<int> ertekelesei;
	int osszeg = 0, darab = 0;
	for (auto &uzenet : g_uzenetek)
	{
		if (uzenet.cimzett == da && IsNumber(uzenet.tartalom))
		{
			osszeg += stoi(uzenet.tartalom);
			darab++;
		}
	}

	if (darab)
	{
		cout << "A munkatrs rtkelseinek szma: " << darab << ", tlaga: " << osszeg / darab << endl;
	}
	else
	{
		cout << "A munkatrsnak nincsenek rtkelsei.";
	}
}

// Projekt adatainak megtekintse
void ProjektAdatai()
{
	cout << "Vlasszon projektet: " << endl;
	for (auto &elem : g_projektek)
	{
		cout << "\t" << elem.first << ". " << elem.second.nev << endl;
	}
	cout << "Projekt szma: ";

	int projektszam = 0;
	cin >> projektszam;
	cin.clear();
	cin.ignore(100, '\n');

	if (g_projektek.find(projektszam) == g_projektek.end())
	{
		cout << "Nincs ilyen projekt!" << endl;
		return;
	}
	cout << endl;
	
	auto &projekt = g_projektek[projektszam];
	cout << "A projektben rsztvet munkatrsak: " << endl;

	// Munkatrsak kirsa
	for (auto &tagsag : g_tagsagok)
	{
		if (tagsag.projekt == projektszam)
		{
			cout << "\t" << g_dolgozok[tagsag.munkatars].nev;
			if (tagsag.vezeto)
				cout << " (vezet)";
			cout << endl;
		}
	}

	// zenetek megszmllsa
	int uzenetek = 0, ertekelesek = 0, ertekelesatlag = 0;
	for (auto &uzenet : g_uzenetek)
	{
		if (uzenet.projekt == projektszam)
		{
			if (IsNumber(uzenet.tartalom))
			{
				ertekelesek++;
				ertekelesatlag += stoi(uzenet.tartalom);
			}
			else
			{
				uzenetek++;
			}
		}
	}

	cout << "zenetek szma: " << uzenetek << endl;
	if (ertekelesek)
	{
		ertekelesatlag /= ertekelesek;
		cout << "rtkelsek szma: " << ertekelesek << " tlaguk: " << ertekelesatlag << endl;
	}
	else
	{
		cout << "Nincsenek rtkelsek" << endl;
	}
	cout << endl;
}

// j projekt ltrehozsa
void UjProjekt()
{
	cout << "j projekt indtsa" << endl;
	cout << "Projekt neve: ";
	string nev;
	cin >> nev;

	// Munkatrsak s vezetk megszmllsa s kirsa
	int munkatarsakszama = 0;
	int vezetokszama = 0;
	for (auto &dolgozo : g_dolgozok)
	{
		if (!dolgozo.second.vezeto)
		{
			if (munkatarsakszama == 0)
				cout << "Vlaszthat munkatrsak: " << endl;

			cout << "\t" << dolgozo.first << ". " << dolgozo.second.nev;
			if (Vezetoe(dolgozo.first))
			{
				vezetokszama++;
				cout << " (mr vezet)";
			}

			cout << endl;
			munkatarsakszama++;
		}
	}
	if (munkatarsakszama == 0)
	{
		cout << "Nincsenek vlaszthat munkatrsak!" << endl;
		return;
	}
	if (munkatarsakszama == vezetokszama)
	{
		cout << "Nincsenek vezetnek vlaszthat munkatrsak!" << endl;
		return;
	}

	cout << "Vezet szma: ";
	int vezetoszama = 0;
	bool vezeto;
	do
	{
		if (!(cin >> vezetoszama))
		{
			cin.clear();
			cin.ignore(100, '\n');
			return;
		}
		cin.clear();
		cin.ignore(100, '\n');

		vezeto = Vezetoe(vezetoszama);
		if (vezeto)
		{
			cout << "Ez a munkatrs mr vezet egy projektnl, vlassz msikat: ";
			vezetoszama = 0;
		}
	} while (vezeto);

	// Maximum kivlaszts
	// Az j projekt azonostja legyen a legutols projekt utni azonost,
	// Vagy 1, ha nincsenek projektek
	int projektszama = 0;
	for (auto &projekt : g_projektek)
	{
		if (projektszama < projekt.first)
			projektszama = projekt.first;
	}
	projektszama++;

	SProjekt projekt = { nev, MaiDatum(), "" };
	g_projektek[projektszama] = projekt;

	STagsag tagsag = { projektszama, vezetoszama, true };
	g_tagsagok.push_back(tagsag);

	cout << "Projekthez hozzadand munkatrsak azonostja (szkzzel elvlasztva): " << endl;
	{
		string line;
		getline(cin, line);

		// A beolvasott sor feldarabolsa intekre
		int munkatars;
		istringstream ss(line);
		set<int> marhozzaadva; // Figyeljk, hogy ne adjunk hozz egy dolgozt tbbszr
		while (ss >> munkatars)
		{
			// Ha ltezik a dolgoz, nem a kivlasztott vezet, nem vezet s mg nincs hozzadva
			if (g_dolgozok.find(munkatars) != g_dolgozok.end()
				&& munkatars != vezetoszama
				&& !g_dolgozok[munkatars].vezeto
				&& marhozzaadva.find(munkatars) == marhozzaadva.end())
			{
				cout << "\t" << g_dolgozok[munkatars].nev << " hozzadva" << endl;

				STagsag tagsag = { projektszama, munkatars, false };
				g_tagsagok.push_back(tagsag);

				marhozzaadva.insert(munkatars);
			}
		}
	}

	MentesProjektek();
	MentesTagsagok();
	cout << "Projekt ltrehozva" << endl;
}

// Projekt lezrsa
void ProjektLezaras()
{
	cout << "Vlasszon projektet: " << endl;
	for (auto &projekt : g_projektek)
	{
		if (projekt.second.befejezo_datum == "")
			cout << "\t" << projekt.first << ". " << projekt.second.nev << endl;
	}
	cout << "Projekt szma: ";

	int projektszam;
	cin >> projektszam;
	cin.clear();
	cin.ignore(100, '\n');

	if (g_projektek.find(projektszam) != g_projektek.end())
	{
		auto &projekt = g_projektek[projektszam];
		if (projekt.befejezo_datum == "")
		{
			projekt.befejezo_datum = MaiDatum();
			MentesProjektek();
			cout << "Projekt lezrva" << endl;
		}
		else
		{
			cout << "Ez a projekt mr le van zrva" << endl;
		}
	}
}

// Szabad munkatrsak felsorolsa
void SzabadMunkatarsak()
{
	bool volt = false;
	for (auto &dolgozo : g_dolgozok)
	{
		// Ellenrizzk, hogy dolgozik-e valamelyik projekten a dolgoz
		bool dolgozik = false;
		for (auto &tagsag : g_tagsagok)
		{
			if (tagsag.munkatars == dolgozo.first)
			{
				dolgozik = true;
				break;
			}
		}

		if (!dolgozik)
		{
			if (!volt)
			{
				cout << "A jelenleg szabad munkatrsak:" << endl;
				volt = true;
			}
			cout << "\t" << dolgozo.first << ". " << dolgozo.second.nev << endl;
		}
	}
	if (!volt)
		cout << "Nincsenek jelenleg szabad munkatrsak." << endl;
}

// Munkatrsak felsorolsa projektjeik szma szerint
void MunktarasakProjektekSzerint()
{
	cout << "A munkatrsak felsorolsa projektjeik szma szerint rendezve:" << endl;

	// munkatars.first = projektjeinek szma, munkatars.second = munkatrs azonostja
	vector<pair<int, int>> munkatarsak;
	for (auto &dolgozo : g_dolgozok)
	{
		// Megszmoljuk, hny projekten dolgozik
		int projektek = 0;
		for (auto &tagsag : g_tagsagok)
		{
			if (tagsag.munkatars == dolgozo.first)
			{
				projektek++;
			}
		}
		munkatarsak.push_back({ projektek, dolgozo.first });
	}

	if (munkatarsak.size())
	{
		// Rendezs cskken sorrendben (first, second) alapjn lexikografikusan
		sort(munkatarsak.rbegin(), munkatarsak.rend());

		for (auto &munkatars : munkatarsak)
		{
			cout << "\t" << munkatars.first << ": " << g_dolgozok[munkatars.second].nev << endl;
		}
	}
	else
	{
		cout << "Nincsenek munkatrsak." << endl;
	}
}

// A legtbb zenetet kld munkatrs kirsa
void LegtobbUzenet()
{
	if (!g_dolgozok.size())
	{
		cout << "Nincsenek dolgozk!" << endl;
		return;
	}

	if (!g_uzenetek.size())
	{
		cout << "Senki se kldtt mg zenetet!" << endl;
		return;
	}
	
	// Kigyjtjk, melyik dolgoz mennyi zenetet kldtt
	map<int,int> dolgozokuldott;
	for (auto &uzenet : g_uzenetek)
	{
		dolgozokuldott[uzenet.felado]++;
	}

	// Megnzzk, mennyi volt a legtbb kldtt zenet
	int legtobb = 0;
	for (auto &dolgozo : dolgozokuldott)
	{
		if (dolgozo.second > legtobb)
			legtobb = dolgozo.second;
	}

	// Kirjuk, kik kldtek ennyit
	cout << "A legtbb zenetet kld munkatrs(ak): " << endl;
	for (auto &dolgozo : g_dolgozok)
	{
		if (dolgozokuldott[dolgozo.first] == legtobb)
		{
			cout << "\t" << dolgozo.first << ". " << dolgozo.second.nev << " uzenetek: " << legtobb << endl;
		}
	}
}

void VezetoiFelulet(int dolgozo)
{
	while(true)
	{
		CleanScreen();
		cout << "Vezeti Fellet" << endl << endl;

		// Menpontok
		cout << "Vlasszon menpontot:" << endl
			<< "\t1. Egy munkatrs adatainak megtekintse" << endl
			<< "\t2. Egy projekt adatainak megtekintse" << endl
			<< "\t3. j projekt indtasa" << endl
			<< "\t4. Projekt lezrsa" << endl
			<< "\t5. A jelenleg szabad munkatrsak felsorolsa" << endl
			<< "\t6. A munkatrsak felsorolsa (Projektjeik szma szerint rendezve)" << endl
			<< "\t7. A legtbb zenetet kld munkatrs kirsa" << endl
			<< "\t0. Kilps" << endl << endl
			<< "Menpont szma: ";

		// Vlasztott menpont szmnak bekrse
		int menu = 0;
		cin >> menu;
		cin.clear();
		cin.ignore(100, '\n');

		while (menu < 0 || menu > 7)
		{
			cout << "Nincs ilyen menpont: " << menu << ", vlasszon msikat: " << endl;
			cin >> menu;
			cin.clear();
			cin.ignore(100, '\n');
		}

		CleanScreen();

		switch (menu)
		{
		case 1:
			MunkatarsAdatok();
			break;
		case 2:
			ProjektAdatai();
			break;
		case 3:
			UjProjekt();
			break;
		case 4:
			ProjektLezaras();
			break;
		case 5:
			SzabadMunkatarsak();
			break;
		case 6:
			MunktarasakProjektekSzerint();
			break;
		case 7:
			LegtobbUzenet();
			break;
		default:
			return;
		}
		cout << endl;
		Pause();
	}
}